/* =================================================================================
 *  mainListe.c
 * =================================================================================
 *  Programma di test per esercizi su liste di interi
 *  Author:      Irene Finocchi  (finocchi@di.uniroma1.it)
 *  Last change: 18 Aprile 2005
 *  Changed by:  Irene Finocchi
*/

#include "liste.h"

int main(void) {

	ListPtr L1=NULL, L2=NULL, L=NULL;

    printf("Costruzione della prima lista: inserisci una sequenza\n");
    printf("non vuota di numeri interi, terminando con -1.\n");
	printf("Esempio: 1 3 5 7 9 10 13 17 19 -1\n");

	L1=crealista();

    printf("Costruzione della seconda lista: inserisci una sequenza\n");
    printf("non vuota di numeri interi, terminando con -1.\n");
	printf("Esempio: 2 3 4 6 7 9 11 12 17 20 -1\n");

	L2=crealista();

    printf("\nCalcola l'intersezione in modo inefficiente.\n\n");

	L=intersezione(L1,L2);

	if (L==NULL) printf("La lista intersezione e' vuota.\n\n");
	else {
		printf("La lista intersezione e': ");
		stampaLista(L);
		printf("\n\n");
	}

    printf("Verifica che le liste siano ordinate.\n\n");

	if (verificaOrdinamento(L1)==0) {
		printf("La prima lista non e' ordinata: non e' possibile calcolare l'intersezione in modo efficiente.\n");
		return 1;
	}

	if (verificaOrdinamento(L2)==0) {
		printf("La seconda lista non e' ordinata: non e' possibile calcolare l'intersezione in modo efficiente.\n");
		return 1;
	}
	
    printf("Calcola l'intersezione in modo efficiente.\n\n");

	L=intersezioneOrdinate(L1,L2);

	if (L==NULL) printf("\nLa lista intersezione e' vuota.\n");
	else {
		printf("\nLa lista intersezione e': ");
		stampaLista(L);
		printf("\n");
	}

	printf("\n");

	return 1;
}





